Subject: Re: linux-next: Tree for January 15 (Call Trace in fs/dcache.c + autofs4)

From: Al Viro <[email-masked]>
Date: Sat, 15 Jan 2011 09:07:02 +0000

On Sat, Jan 15, 2011 at 07:57:23AM +0000, Al Viro wrote:
> On Sat, Jan 15, 2011 at 08:46:20AM +0100, Sedat Dilek wrote:
> 
> > Will try the patch from [1] as there was no feedback yet.
> > 
> > - Sedat -
> > 
> > [1] https://lkml.org/lkml/2011/1/12/394
> 
> There's also vfsmount refcounting breakage somewhere in automount series,
> unfortunately caught only when redoing said refcounting on top of it [1] ;-/
> I'm bisecting it right now, will post when it's done.
> 
> [1] with mnt{get,put}_long() variant the breakage is present, but not
> immediately noticable.  With (local) rewrite to saner rules it became
> visible, but I spent quite a while trying to find the bug in the most
> obvious place - i.e. that rewrite.

Argh...  In __do_follow_link() replace

	if (link->mnt != nd->path.mnt)
with
	if (link->mnt == nd->path.mnt)

Mismerge yesterday ;-/  I've pushed fix for that in for-next, will fold
shortly.  As for autofs4 breakage, I've a preliminary fix, testing it
now.